;Ŀ
;                 Joe Forster/STA                 
;                                                 
;                    CONV.ASM                     
;                                                 
;                 File Converter                  
;

CSeg		segment
		assume	cs:CSeg, ds:CSeg, ss:CSeg
		org	0100h

BufferSize	equ	64512
ProgramSize	equ	4096

Main:		mov	ax, ds:[0006h]
		cmp	ax, ProgramSize
		jbe	@16
		mov	bx, ProgramSize / 16
		mov	ah, 4Ah
		int	21h
		mov	sp, ProgramSize
		xor	ax, ax
		push	ax
@16:		mov	di, Offset DataStart
		mov	cx, DataEnd - DataStart
		xor	al, al
		cld
		rep	stosb
		mov	dx, Offset Hello
		mov	ah, 9
		int	21h
		mov	bl, 2
		mov	di, Offset ConvName
		mov	cx, 79
		call	ParamStr
		cmp	bh, 2
		je	@01
		mov	dx, Offset Usage
		mov	ah, 9
		int	21h
		xor	al, al
		jmp	@03
@01:		mov	bl, 1
		mov	di, Offset SearchPar
		mov	cx, 79
		call	ParamStr
@20:		mov	dx, Offset ConvName
		mov	ax, 3D00h
		int	21h
		jc	@19
		jmp	@17
@19:		cmp	RetriedHomeDir, 0
		jne	@21
		mov	si, dx
@23:		lodsb
		or	al, al
		je	@22
		cmp	al, ':'
		je	@21
		cmp	al, '\'
		je	@21
		jne	@23
@22:		mov	si, Offset ConvName
		mov	di, Offset ReadPath
		mov	bx, Offset ReadName
		mov	bp, Offset ReadExt
		call	FSplit
		xor	al, al
		mov	es, cs:[002Ch]
		xor	di, di
		cld
@24:		cmp	al, es:[di]
		je	@25
		mov	cx, -1
		repne	scasb
		jmp	@24
@25:		add	di, 3
		push	ds
		push	es
		pop	ds
		pop	es
		mov	si, di
		mov	di, Offset ReadPath
		xor	bx, bx
		xor	bp, bp
		call	FSplit
		push	cs
		pop	ds
		mov	si, Offset ReadPath
		mov	di, Offset ConvName
		mov	cx, 79
		clc
		call	StrCopy
		mov	si, Offset ReadName
		clc
		call	StrCopy
		mov	si, Offset ReadExt
		stc
		call	StrCopy
		inc	RetriedHomeDir
		jmp	@20
@21:		mov	dx, Offset ConvName
		clc
		call	PrintStr
		mov	dx, Offset NotFound
		jmp	@02
@17:		mov	bx, ax
		mov	dx, Offset ConvertTable[1]
		mov	cx, 255
		mov	ah, 3Fh
		int	21h
@18:		mov	ah, 3Eh
		int	21h
		mov	si, Offset SearchPar
		mov	di, Offset ReadPath
		mov	bx, Offset ReadName
		mov	bp, Offset ReadExt
		call	FSplit
		mov	si, Offset ReadPath
		mov	di, Offset SearchPar
		mov	cx, 79
		clc
		call	StrCopy
		mov	si, Offset ReadName
		clc
		call	StrCopy
		mov	si, Offset ReadExt
		stc
		call	StrCopy
		mov	dx, Offset SearchPar
		mov	cx, 27h
		mov	ah, 4Eh
		int	21h
		jnc	@06
		mov	dx, Offset SearchPar
		clc
		call	PrintStr
		mov	dx, Offset NotFound
		jmp	@02
@06:		mov	si, 009Eh
		xor	di, di
		mov	bx, Offset ReadName
		mov	bp, Offset ReadExt
		call	FSplit
		mov	si, Offset ReadPath
		mov	di, Offset SearchPar
		mov	cx, 79
		clc
		call	StrCopy
		mov	si, 009Eh
		stc
		call	StrCopy
		mov	si, Offset ReadPath
		mov	di, Offset WriteName
		mov	cx, 79
		clc
		call	StrCopy
		mov	si, Offset ReadName
		clc
		call	StrCopy
		mov	si, Offset CNVExt
		stc
		call	StrCopy
		mov	dx, Offset SearchPar
		mov	ax, 3D00h
		int	21h
		jnc	@07
		jmp	@04
@07:		mov	si, ax
		mov	dx, Offset WriteName
		xor	cx, cx
		mov	ah, 3Ch
		int	21h
		jnc	@08
		jmp	@09
@08:		mov	di, ax
		mov	bx, BufferSize / 16
		mov	ah, 48h
		int	21h
		jnc	@10
		mov	dx, Offset NoMemory
		jmp	@02
@10:		mov	Buffer, ax
		mov	dx, Offset Converting
		mov	ah, 9
		int	21h
		mov	dx, Offset SearchPar
		clc
		call	PrintStr
		mov	dx, Offset Conjunctive
		mov	ah, 9
		int	21h
		mov	dx, Offset WriteName
		stc
		call	PrintStr
		mov	bx, si
		mov	ax, 4202h
		xor	cx, cx
		xor	dx, dx
		int	21h
		mov	word ptr ReadLen[0], ax
		mov	word ptr ReadLen[2], dx
		mov	ax, 4200h
		xor	cx, cx
		xor	dx, dx
		int	21h
		mov	ax, 5700h
		int	21h
		mov	Time, cx
		mov	Date, dx
		xor	ax, ax
		mov	word ptr Pos[0], ax
		mov	word ptr Pos[2], ax
@14:		mov	ax, word ptr ReadLen[0]
		mov	dx, word ptr ReadLen[2]
		mov	bx, word ptr Pos[0]
		mov	cx, word ptr Pos[2]
		sub	ax, bx
		sbb	dx, cx
		jc	@15
		or	dx, dx
		jne	@11
		or	ax, ax
		je	@15
		cmp	ax, BufferSize
		jbe	@12
@11:		mov	ax, BufferSize
@12:		mov	cx, ax
		mov	ax, word ptr Pos[0]
		mov	dx, word ptr Pos[2]
		add	ax, cx
		adc	dx, 0
		mov	word ptr Pos[0], ax
		mov	word ptr Pos[2], dx
		mov	bx, si
		mov	ax, Buffer
		call	BlockRead
		push	ds
		push	cx
		xor	bp, bp
		mov	bx, Offset ConvertTable
		mov	ds, cs:Buffer
@05:		mov	al, ds:[bp]
		xlat	cs:[bx]
		mov	ds:[bp], al
		inc	bp
		loop	@05
		pop	cx
		pop	ds
		mov	bx, di
		mov	ax, Buffer
		call	BlockWrite
		jmp	@14
@15:		push	es
		mov	es, Buffer
		mov	ah, 49h
		int	21h
		pop	es
		mov	bx, di
		mov	ax, 5701h
		mov	cx, Time
		mov	dx, Date
		int	21h
		mov	ah, 3Eh
		int	21h
@09:		mov	bx, si
		mov	ah, 3Eh
		int	21h
@04:		mov	ah, 4Fh
		int	21h
		jc	@03
		jmp	@06
@02:		mov	ah, 9
		int	21h
		mov	al, 1
		jmp	@26
@03:		xor	al, al
@26:		mov	ah, 4Ch
		int	21h

BlockRead:	push	ds
		push	dx
		mov	ds, ax
		xor	dx, dx
		mov	ah, 3Fh
		int	21h
		pop	dx
		pop	ds
		retn

BlockWrite:	push	ds
		push	dx
		mov	ds, ax
		xor	dx, dx
		mov	ah, 40h
		int	21h
		pop	dx
		pop	ds
		retn

FSplit:		mov	dx, si
		call	StrLen
		add	si, ax
		dec	si
		xor	cx, cx
		std
@04_FSplit:	cmp	si, dx
		jb	@01_FSplit
		lodsb
		cmp	al, '.'
		jne	@02_FSplit
		or	cx, cx
		jne	@02_FSplit
		mov	cx, si
		inc	cx
@02_FSplit:	cmp	al, '\'
		je	@03_FSplit
		cmp	al, ':'
		jne	@04_FSplit
@03_FSplit:	inc	si
@01_FSplit:	inc	si
		or	cx, cx
		jne	@05_FSplit
		mov	cx, dx
		xchg	si, dx
		call	StrLen
		xchg	si, dx
		add	cx, ax
@05_FSplit:	xchg	si, dx
		sub	cx, dx
		sub	dx, si
		push	cx
		mov	cx, 67
		stc
		call	StrPartCopy
		mov	di, bx
		pop	dx
		mov	cx, 8
		stc
		call	StrPartCopy
		mov	di, bp
		mov	cx, 4
		stc
		call	StrCopy
		retn

StrCopy:	mov	dx, cx
StrPartCopy:	cld
		pushf
		or	di, di
		jne	@04_StrCopy
		popf
		retn
@04_StrCopy:	or	cx, cx
		je	@01_StrCopy
@02_StrCopy:	or	dx, dx
		je	@01_StrCopy
		lodsb
		or	al, al
		je	@01_StrCopy
		stosb
		dec	dx
		loop	@02_StrCopy
@01_StrCopy:	xor	al, al
		popf
		jnc	@03_StrCopy
		stosb
@03_StrCopy:	retn

StrLen:		cld
		push	si
		xor	ah, ah
@02_StrLen:	lodsb
		or	al, al
		je	@01_StrLen
		inc	ah
		or	ah, ah
		jne	@02_StrLen
@01_StrLen:	pop	si
		mov	al, ah
		xor	ah, ah
		retn

PrintStr:	push	si
		push	bx
		push	cx
		pushf
		mov	si, dx
		mov	bx, 1
		call	StrLen
		or	ax, ax
		je	@01_PrintStr
		mov	cx, ax
		mov	ah, 40h
		int	21h
@01_PrintStr:	popf
		jnc	@02_PrintStr
		mov	dx, Offset LineFeed
		mov	cx, 2
		mov	ah, 40h
		int	21h
@02_PrintStr:	pop	cx
		pop	bx
		pop	si
		retn

ParamStr:	mov	si, 0081h
		xor	bh, bh
@01_ParamStr:	lodsb
		cmp	al, 13
		je	@02_ParamStr
		cmp	al, ' '
		je	@01_ParamStr
		cmp	al, 9
		je	@01_ParamStr
		inc	bh
		cmp	bl, bh
		je	@03_ParamStr
@04_ParamStr:	cmp	al, 13
		je	@02_ParamStr
		cmp	al, ' '
		je	@01_ParamStr
		cmp	al, 9
		je	@01_ParamStr
		lodsb
		jmp	@04_ParamStr
@03_ParamStr:	or	di, di
		je	@05_ParamStr
@06_ParamStr:	cmp	al, 13
		je	@02_ParamStr
		cmp	al, ' '
		je	@02_ParamStr
		cmp	al, 9
		je	@02_ParamStr
		call	UpCase
		stosb
		lodsb
		loop	@06_ParamStr
@02_ParamStr:	xor	al, al
		stosb
@05_ParamStr:	retn

UpCase:		cmp	al, 'a'
		jb	@01_UpCase
		cmp	al, 'z'
		ja	@01_UpCase
		sub	al, 'a' - 'A'
@01_UpCase:	retn

Hello		db	'File Converter by Joe Forster/STA', 13, 10, 13, 10, '$'
Usage		db	'This program converts files using translation tables.', 13, 10, 13, 10
		db	'Usage: CONV <filename> <translate-file>', 13, 10, '$'
NotFound	db	' not found', 13, 10, '$'
NoMemory	db	'Out of memory', 13, 10, '$'
InvalidNumber	db	'Invalid number', 13, 10, '$'
Converting	db	'Converting $'
Conjunctive	db	' to $'
LineFeed	db	13, 10
CNVExt		db	'.CNV', 0

DataStart:

ConvertTable	db	256 dup (?)
Time		dw	?
Date		dw	?
FromNum		db	?
ToNum		db	?
ReadLen		dd	?
Pos		dd	?
Buffer		dw	?
BufferLen	dw	?
ReadData	dw	?
RetriedHomeDir	db	?
SearchPar	db	79 + 1 dup (?)
ConvName	db	79 + 1 dup (?)
WriteName	db	79 + 1 dup (?)
ReadPath	db	79 + 1 dup (?)
ReadName	db	8 + 1 dup (?)
ReadExt		db	4 + 1 dup (?)

DataEnd:

CSeg		ends

		end	Main
